//////////////////////////////////////////////////////////////////////
//
//                             Pixie
//
// Copyright  1999 - 2003, Okan Arikan
//
// Contact: okan@cs.berkeley.edu
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//
//  File				:	colormap.h
//  Classes				:	CColorMap
//  Description			:
//
////////////////////////////////////////////////////////////////////////
#ifndef COLORMAP_H
#define COLORMAP_H

#include "common/global.h"		// The global header file
#include "options.h"


///////////////////////////////////////////////////////////////////////
// Class				:	CColorMap
// Description			:	Encapsulates a color mapper
// Comments				:
// Date last edited		:	3/29/2003
class	CColorMap : public CFileResource {
public:
				CColorMap(const char *);
				~CColorMap();

	void		lookup(float *,const float);

	int			numColors;
	float		*colors;
	float		*temperatures;
};

#endif




